package com.game.business.task;

import cn.hutool.core.date.DateUtil;
import com.game.business.domain.*;
import com.game.business.service.IAppUserService;
import com.game.business.service.IAppUsersCashrecordService;
import com.game.business.service.IAppUsersChargeService;
import com.game.business.service.IFinTranRecordService;
import com.game.common.utils.DateUtils;
import com.game.common.utils.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Component
public class AppUserCountTask {

    @Autowired
    private IAppUsersChargeService appUsersChargeService;

    @Autowired
    private IAppUserService appUserService;

    @Autowired
    private IAppUsersCashrecordService appUsersCashrecordService;

    @Autowired
    private IFinTranRecordService finTranRecordService;


    /**
     * 统计用户前一天
     * */
    public void statistics(String dateTime){
        Date curDate = DateUtil.offsetDay(DateUtils.getNowDate(),-1);
        if(StringUtils.isNotBlank(dateTime)){
            curDate = DateUtil.parse(dateTime,"yyyy-MM-dd");
        }else{
            dateTime = DateUtils.parseDateToStr("yyyy-MM-dd",curDate);
        }
        List<AppUser> list = appUserService.selectAppUserList(new AppUser());//查询所有用户
        List<AppUsersCharge> appUsersChargeList = appUsersChargeService.getChargeList(null,dateTime.concat(" 00:00:00"),dateTime.concat(" 23:59:59"));
        List<AppUsersCashrecord> appUsersCashrecords = appUsersCashrecordService.getUserCashList(null,dateTime.concat(" 00:00:00"),dateTime.concat(" 23:59:59"));
//        List<FinTranRecord> finTranRecordList = finTranRecordService.getUserRecordList(null,)
        if(null != list && list.size()>0){
            List<AppUserCount> appUserCountList = new ArrayList<>();
            String finalDateTime = dateTime;
            list.forEach(appUser -> {
                AppUserCount appUserCount = new AppUserCount();
                appUserCount.setUserId(appUser.getUserid());
                appUserCount.setStrDate(finalDateTime);
                appUserCount.setAgentUserId(appUser.getPid());
                //充值总额
                appUserCount.setRechargeAmount(appUsersChargeList.stream().filter(e->e.getUid().equals(appUser.getUserid())).mapToDouble(e->e.getMoney().doubleValue()).sum());
                //提现金额
                appUserCount.setWithdrawalAmount(appUsersCashrecords.stream().filter(e->e.getUid().equals(appUser.getUserid())).mapToDouble(e->e.getMoney().doubleValue()).sum());
                //提现服务费/手续费
                appUserCount.setWithdrawalCommission(appUsersCashrecords.stream().filter(e->e.getUid().equals(appUser.getUserid())).mapToDouble(e->e.getService().doubleValue()).sum());
            });
        }

    }

}
